System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Component, director, gfx, Texture2D, _dec, _dec2, _class, _class2, _descriptor, _temp, _crd, ccclass, property, Test;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      director = _cc.director;
      gfx = _cc.gfx;
      Texture2D = _cc.Texture2D;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e79d72i7DFO54435zCG8QGE", "test", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("Test", Test = (_dec = ccclass('Test'), _dec2 = property(Texture2D), _dec(_class = (_class2 = (_temp = class Test extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "texture", _descriptor, this);

          _defineProperty(this, "sourceData", null);
        }

        start() {
          this.readPixels();
          const numberOfEnclosedShapes = this.countEnclosedShapes(this.texture.width, this.texture.height);
          console.log("能够形成的包围图形数量:", numberOfEnclosedShapes);
        }

        readPixels() {
          this.sourceData = this.readTexturePixels(this.texture);
        }

        countEnclosedShapes(width, height) {
          const grid = Uint8Array.from(this.sourceData);
          const visited = new Uint8Array(grid.length / 4); // 记录每个像素是否已被访问
          // 定义迭代的洪水填充算法

          const floodFill = (x, y) => {
            const stack = [{
              x,
              y
            }];

            while (stack.length > 0) {
              const {
                x,
                y
              } = stack.pop(); // 计算当前像素在一维数组中的索引

              const index = y * width + x; // 检查边界条件和透明度

              if (x < 0 || x >= width || y < 0 || y >= height || visited[index] || grid[index * 4 + 3] === 0) {
                // 检查透明度（A）
                continue;
              }

              visited[index] = 1; // 标记为已访问
              // 将四个邻接的点加入栈

              stack.push({
                x: x + 1,
                y
              });
              stack.push({
                x: x - 1,
                y
              });
              stack.push({
                x,
                y: y + 1
              });
              stack.push({
                x,
                y: y - 1
              });
            }
          };

          let shapeCount = 0; // 遍历像素网格进行填充

          for (let y = 0; y < height; y++) {
            for (let x = 0; x < width; x++) {
              const index = y * width + x; // 检查目前的像素是否未被访问和透明度不为0

              if (!visited[index] && grid[index * 4 + 3] !== 0) {
                // 透明度不为0
                floodFill(x, y); // 从这个点开始填充

                shapeCount++; // 成功填充一个区域，计数
              }
            }
          }

          return shapeCount;
        }
        /**
         * 读取texture的像素到一个buffer
         * @param texture texture原图
         * @param width 
         * @param height 
         * @param x 
         * @param y 
         * @returns 
         */


        readTexturePixels(texture, x = 0, y = 0) {
          const gfxTexture = texture.getGFXTexture();
          if (gfxTexture == null) return null;
          const bufferSize = 4 * texture.width * texture.height;
          const buffer = new Uint8Array(bufferSize);
          const region = new gfx.BufferTextureCopy();
          region.texOffset.x = x;
          region.texOffset.y = y;
          region.texExtent.width = texture.width;
          region.texExtent.height = texture.height;
          director.root.device.copyTextureToBuffers(gfxTexture, [buffer], [region]);
          return buffer;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "texture", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=test.js.map